Bug 92438 - Segfault in pushbuf_kref on nv50 when rendering from multiple threads
Summary: Segfault in pushbuf_kref on nv50 when rendering from multiple threads
Status: ASSIGNED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/nouveau (show other bugs)
Version: 11.0
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Nouveau Project
QA Contact: Nouveau Project
URL:
Whiteboard:
Keywords:
Depends on: 92077
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-12 12:59 UTC by Gabriele Svelto
Modified: 2017-01-02 07:37 UTC (History)
1 user (show)

See Also:
i915 platform:
i915 features:


Attachments
kernel log (145.58 KB, text/plain)
2015-10-12 12:59 UTC, Gabriele Svelto
Details
X log (47.41 KB, text/plain)
2015-10-12 13:00 UTC, Gabriele Svelto
Details
kernel log (114.83 KB, text/plain)
2015-10-13 20:19 UTC, Gabriele Svelto
Details
X log (32.00 KB, text/plain)
2015-10-13 20:19 UTC, Gabriele Svelto
Details
deal with bind == 0 (748 bytes, text/plain)
2015-11-01 07:36 UTC, Ilia Mirkin
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Gabriele Svelto 2015-10-12 12:59:46 UTC
Created attachment 118838 [details]
kernel log

I've encountered an easily reproducible segfault using the Firefox OS emulator while I was hacking the said operating. The Firefox OS emulator [1] is a fork of the Android emulator which is in turn a fork of qemu. In both cases the graphics part is untouched so it might be possible to reproduce the same issue in qemu even though I didn't have the time to try it.

Here's my full STR:

1) Build the Firefox OS emulator using the emulator-x86-kk target device ( git clone https://github.com/mozilla-b2g/B2G.git ; cd B2G ; ./config.sh emulator-x86-kk ; ./build.sh )
2) Launch it from the tree using the run-emulator.sh script
3) Once Firefox OS has started quickly click on any application and keep clicking on buttons / input boxes / etc... The segfault will normally happen in a matter of seconds

I've reproduced the bug both on Fedora 22 and Gentoo so it doesn't look like distro-specific, these are the versions number taken from my Gentoo installation:

xf86-video-nouveau 1.0.11
libdrm 2.4.59
mesa 10.3.7
xorg-server 1.16.4
kernel 4.0.5

I've captured a stack trace of the segfault with gdb:

Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread 0xc3dfeb40 (LWP 9387)]
0xf689a323 in pushbuf_kref () from /usr/lib32/libdrm_nouveau.so.2
(gdb) bt
#0  0xf689a323 in pushbuf_kref () from /usr/lib32/libdrm_nouveau.so.2
#1  0xf689ab9f in pushbuf_validate () from /usr/lib32/libdrm_nouveau.so.2
#2  0xf6ce47e8 in nv50_state_validate () from /usr/lib32/dri/nouveau_dri.so
#3  0xf6cf0a49 in nv50_draw_vbo () from /usr/lib32/dri/nouveau_dri.so
#4  0xf6b3846d in cso_draw_vbo () from /usr/lib32/dri/nouveau_dri.so
#5  0xf6a5f29e in st_draw_vbo () from /usr/lib32/dri/nouveau_dri.so
#6  0xf6a30cd3 in vbo_draw_arrays () from /usr/lib32/dri/nouveau_dri.so
#7  0xf6a30f37 in vbo_exec_DrawArrays () from /usr/lib32/dri/nouveau_dri.so
#8  0xf72ca52b in glDrawArrays (mode=4, first=0, count=6) at sdk/emulator/opengl/host/libs/Translator/GLES_V2/GLESv2Imp.cpp:576
#9  0xf74b9965 in gl2_decoder_context_t::decode (this=0xc3dfdfd4, buf=0xc47ff008, len=5452, stream=0xc6400768)
    at out/host/linux-x86/obj/STATIC_LIBRARIES/libGLESv2_dec_intermediates/gl2_dec.cpp:565
#10 0xf74b662c in RenderThread::Main (this=0xc6400788) at sdk/emulator/opengl/host/libs/libOpenglRender/RenderThread.cpp:128
#11 0xf74cdc3d in osUtils::Thread::thread_main (p_arg=0xc6400788) at sdk/emulator/opengl/shared/OpenglOsUtils/osThreadUnix.cpp:83
#12 0xf7f9711f in start_thread () from /lib32/libpthread.so.0
#13 0xf7d5f79e in clone () from /lib32/libc.so.6

I'm attaching the kernel log and the X log. Those may be "polluted" by other stuff as my machine has been running for some time since I've hit the bug. I'll try to provide cleaner ones right after I hit the bug. If more detailed information is needed (e.g. a backtrace with finer-grained debug information, etc...) I can provide it given some time to gather it.

[1] https://developer.mozilla.org/en-US/docs/Mozilla/Firefox_OS/Using_the_B2G_emulators
Comment 1 Gabriele Svelto 2015-10-12 13:00:11 UTC
Created attachment 118839 [details]
X log
Comment 2 Ilia Mirkin 2015-10-12 17:35:19 UTC
Does this still happen with recent mesa (and libdrm)?
Comment 3 Gabriele Svelto 2015-10-12 20:41:21 UTC
I can test it, which version of mesa and libdrm do you suggest? The portage tree seems to have all recent versions.
Comment 4 Gabriele Svelto 2015-10-13 06:41:57 UTC
I've started testing with different versions of mesa and libdrm. On my first try I could still repro with mesa 10.4.6 and libdrm 2.4.59.
Comment 5 Gabriele Svelto 2015-10-13 07:22:07 UTC
Still repros on mesa 10.4.6 and libdrm 2.4.65.
Comment 6 Pierre Moreau 2015-10-13 07:46:53 UTC
FYI, latest Mesa release is 11.0.3. 10.4 was branched out in December 2014 (though it did receive some additional fixes up to March 2015), so you might want to try at least 10.6.x, or even better, 11.0.x.
Comment 7 Gabriele Svelto 2015-10-13 12:08:46 UTC
After some fiddling with the various dependency I'm now testing on mesa 11.0.3. I haven't hit the bug just yet but I want to run the emulator for a while to be sure it's not just luck on my part.
Comment 8 Gabriele Svelto 2015-10-13 20:17:22 UTC
I can still reproduce on mesa 11.0.3 / libdrm 2.4.65 though it takes longer to trigger the bug (a few minutes of usage). This is the backtrace when using these versions of mesa and libdrm, it's somewhat different than the previous one but the bottom frames look the same:

#0  0xf67fc403 in pushbuf_kref () from /usr/lib32/libdrm_nouveau.so.2
#1  0xf67fcc7f in pushbuf_validate () from /usr/lib32/libdrm_nouveau.so.2
#2  0xf6c80f9b in nv50_flush () from /usr/lib32/dri/nouveau_dri.so
#3  0xf69c93a4 in st_flush () from /usr/lib32/dri/nouveau_dri.so
#4  0xf69c93f4 in st_glFlush () from /usr/lib32/dri/nouveau_dri.so
#5  0xf6879b76 in _mesa_flush () from /usr/lib32/dri/nouveau_dri.so
#6  0xf6879f19 in _mesa_make_current () from /usr/lib32/dri/nouveau_dri.so
#7  0xf69fab96 in st_api_make_current () from /usr/lib32/dri/nouveau_dri.so
#8  0xf6ac28f6 in dri_unbind_context () from /usr/lib32/dri/nouveau_dri.so
#9  0xf6ac2337 in driUnbindContext () from /usr/lib32/dri/nouveau_dri.so
#10 0xf73ff3b6 in dri2_unbind_context () from /usr/lib32/libGL.so.1
#11 0xf73d89fb in glXMakeCurrentReadSGI () from /usr/lib32/libGL.so.1
#12 0xf747a89c in EglOS::makeCurrent (dpy=0x8c13608, read=0x0, draw=0x0, ctx=0x0) at sdk/emulator/opengl/host/libs/Translator/EGL/EglX11Api.cpp:263
#13 0xf747eb11 in eglMakeCurrent (display=0x8c20e50, draw=0x0, read=0x0, context=0x0) at sdk/emulator/opengl/host/libs/Translator/EGL/EglImp.cpp:684
#14 0xf74b0787 in FrameBuffer::unbind_locked (this=0x8c20d68) at sdk/emulator/opengl/host/libs/libOpenglRender/FrameBuffer.cpp:790
#15 0xf74ad7f6 in ColorBuffer::create (p_width=320, p_height=266, p_internalFormat=6408) at sdk/emulator/opengl/host/libs/libOpenglRender/ColorBuffer.cpp:108
#16 0xf74b181f in FrameBuffer::createColorBuffer (this=0x8c20d68, p_width=320, p_height=266, p_internalFormat=6408)
    at sdk/emulator/opengl/host/libs/libOpenglRender/FrameBuffer.cpp:489
#17 0xf74b7c2d in rcCreateColorBuffer (width=320, height=266, internalFormat=6408) at sdk/emulator/opengl/host/libs/libOpenglRender/RenderControl.cpp:215
#18 0xf74b9754 in renderControl_decoder_context_t::decode (this=0xc6301d5c, buf=0xacee6008, len=20, stream=0xc6300990)
    at out/host/linux-x86/obj/STATIC_LIBRARIES/lib_renderControl_dec_intermediates/renderControl_dec.cpp:245
#19 0xf74b8655 in RenderThread::Main (this=0xc6301d30) at sdk/emulator/opengl/host/libs/libOpenglRender/RenderThread.cpp:138
#20 0xf74cfc3d in osUtils::Thread::thread_main (p_arg=0xc6301d30) at sdk/emulator/opengl/shared/OpenglOsUtils/osThreadUnix.cpp:83
#21 0xf7f9811f in start_thread () from /lib32/libpthread.so.0
#22 0xf7d6079e in clone () from /lib32/libc.so.6
Comment 9 Gabriele Svelto 2015-10-13 20:19:03 UTC
I'm attaching a new dmesg/Xorg.0.log couple taken just after I hit the bug, they'll be probably easier to parse than the previous one. Especially the dmesg output has some nouveau-related error messages at the bottom.
Comment 10 Gabriele Svelto 2015-10-13 20:19:20 UTC
Created attachment 118859 [details]
kernel log
Comment 11 Gabriele Svelto 2015-10-13 20:19:33 UTC
Created attachment 118860 [details]
X log
Comment 12 Ilia Mirkin 2015-10-15 19:32:33 UTC
[35345.800105] nouveau E[   PFIFO][0000:01:00.0] DMA_PUSHER - ch 6 [emulator-x86[1371]] get 0x00200f9878 put 0x00200f98d0 ib_get 0x000000ed ib_put 0x000000f6 state 0x80000000 (err: INVALID_CMD) push 0x00406040

This is a long-standing and utterly undiagnosed issue. Somehow an invalid command manages to make it onto the pushbuf. [A command as in a FIFO command, like "BEGIN_NV04" style, not like the actual data being fed to the engine.]

There has never been a reproducible way of triggering it. Only seems to happen on tesla GPUs. Either something *very* subtle is going on in mesa, or we're driving the hardware wrong, or... who knows.

Search around for 406040 -- tons of bugs open about this.
Comment 13 Gabriele Svelto 2015-10-15 19:41:39 UTC
Thanks for the info. I can reproduce this bug fairly easily so I can help diagnosing it, would a trace of the OpenGL calls help? This often happens after only a few seconds so it's not going to be a huge one.

BTW I'm not running a GPU from the Tesla family, this is a GeForce 9600GT/NV94.
Comment 14 Ilia Mirkin 2015-10-15 19:53:52 UTC
(In reply to Gabriele Svelto from comment #13)
> Thanks for the info. I can reproduce this bug fairly easily so I can help
> diagnosing it, would a trace of the OpenGL calls help? This often happens
> after only a few seconds so it's not going to be a huge one.
> 
> BTW I'm not running a GPU from the Tesla family, this is a GeForce
> 9600GT/NV94.

NV94 is a tesla. Tesla is G80:MCP89 (aka nv50 family).

If you can make an apitrace that repros it for you consistently on replay that'd be incredibly useful. However I suspect there's more to it and a plain apitrace won't be able to repro the issue.
Comment 15 Gabriele Svelto 2015-10-16 09:00:09 UTC
(In reply to Ilia Mirkin from comment #14)
> NV94 is a tesla. Tesla is G80:MCP89 (aka nv50 family).

Right, my bad, I've got confused with the actual Tesla card.

> If you can make an apitrace that repros it for you consistently on replay
> that'd be incredibly useful. However I suspect there's more to it and a
> plain apitrace won't be able to repro the issue.

I gave it a spin today and the trace I gathered doesn't crash when replaying as you suggested. The bottom of the trace contains an incomplete glFlush() call followed by a glDrawArrays() which is also incomplete. I'll try grabbing more traces in the hope of finding one that reproduces the crash.

Alternatively if you have the appropriate hardware to reproduce I can walk you through how to build this stuff and reproduce yourself (it's a procedure that might take a few hours though, the full Firefox OS emulator build is *large*).
Comment 16 Ilia Mirkin 2015-10-21 22:58:35 UTC
In your kernel log I see

[30903.432610] nouveau E[steam[21937]] fail set_domain
[30903.432614] nouveau E[steam[21937]] validating bo list
[30903.432618] nouveau E[steam[21937]] validate: -22

I believe that error should be fixed by the kernel patch at the end of bug #92504. However I don't think that's your main issue. Still, worth giving it a shot.

Separately, some very subtle fence-related issues should be fixed in the soon-to-be-released Mesa 11.0.4 (or mesa's master branch). Again, don't think they're the root cause of your problems, but... wouldn't hurt to try.
Comment 17 Gabriele Svelto 2015-10-24 12:04:31 UTC
Thanks for the tip. From the comments in that bug I should be able to test that patch in the 4.3+ kernels. I'm rolling my own build so I can try that out as soon as I have some spare time. I'll also try mesa 11.0.4 when it will be available in portage (which should be shortly after release).

I'd also like to do another experiment: traces gathered with apitrace always end up with the seg-faulting command and always work fine when repeating them - possibly because the last command needs to be fully executed to cause the problem. I'll try gathering a much longer trace using the software render and then try to replay that one with apitrace to see if I can trigger the bug. Alternatively this might be a race condition of some sort (I can see in the trace that there's at least 4 threads calling GL commands); possibly re-executing the trace a lot of times might trigger it sooner or later.

I'll report back if I find anything useful.
Comment 18 Gabriele Svelto 2015-10-30 13:04:31 UTC
Quick update, I'm on mesa 11.0.4 now and the issue is still present but it manifests itself differently: when I hit the issue I can still see the error messages being dumped into the kernel log but the application isn't seg-faulting anymore. I'm not sure if this is good or bad; it does help with my use-case as things keep running afterwards but it might make this bug harder to track.
Comment 19 Gabriele Svelto 2015-10-30 13:26:14 UTC
Disregards my previous comment, I've just hit another segfault.
Comment 20 Jim Blandy 2015-10-31 14:15:59 UTC
I'm able to reproduce a crash with a very similar stack on Fedora 22, using the glium Rust OpenGL bindings: https://github.com/tomaka/glium

Here's the stack trace I get:

Program received signal SIGSEGV, Segmentation fault.
0x00007ffff02f66fc in pushbuf_kref () from /lib64/libdrm_nouveau.so.2
Missing separate debuginfos, use: dnf debuginfo-install bzip2-libs-1.0.6-14.fc22.x86_64 elfutils-libelf-0.163-4.fc22.x86_64 elfutils-libs-0.163-4.fc22.x86_64 expat-2.1.0-10.fc22.x86_64 libattr-2.4.47-10.fc22.x86_64 libcap-2.24-7.fc22.x86_64 libdrm-2.4.61-3.fc22.x86_64 libedit-3.1-12.20150325cvs.fc22.x86_64 libffi-3.1-7.fc22.x86_64 libgcc-5.1.1-4.fc22.x86_64 libpciaccess-0.13.3-0.3.fc22.x86_64 libselinux-2.3-10.fc22.x86_64 libstdc++-5.1.1-4.fc22.x86_64 libwayland-client-1.7.0-1.fc22.x86_64 libwayland-server-1.7.0-1.fc22.x86_64 libX11-1.6.3-1.fc22.x86_64 libX11-devel-1.6.3-1.fc22.x86_64 libXau-1.0.8-4.fc22.x86_64 libxcb-1.11-8.fc22.x86_64 libXcursor-devel-1.1.14-4.fc22.x86_64 libXdamage-1.1.4-6.fc22.x86_64 libXext-1.3.3-2.fc22.x86_64 libXfixes-5.0.1-4.fc22.x86_64 libXi-devel-1.7.4-2.fc22.x86_64 libXrender-0.9.9-1.fc22.x86_64 libxshmfence-1.2-1.fc22.x86_64 libXxf86vm-devel-1.1.4-1.fc22.x86_64 llvm-libs-3.5.0-9.fc22.x86_64 mesa-dri-drivers-10.6.9-1.20151008.fc22.x86_64 mesa-libEGL-10.6.9-1.20151008.fc22.x86_64 mesa-libgbm-10.6.9-1.20151008.fc22.x86_64 mesa-libGL-10.6.9-1.20151008.fc22.x86_64 mesa-libglapi-10.6.9-1.20151008.fc22.x86_64 ncurses-libs-5.9-18.20150214.fc22.x86_64 pcre-8.37-5.fc22.x86_64 systemd-libs-219-25.fc22.x86_64 xz-libs-5.2.0-2.fc22.x86_64 zlib-1.2.8-7.fc22.x86_64
(gdb) where
#0  0x00007ffff02f66fc in pushbuf_kref () from /lib64/libdrm_nouveau.so.2
#1  0x00007ffff02f6db9 in pushbuf_validate () from /lib64/libdrm_nouveau.so.2
#2  0x00007ffff0c28ecd in nvc0_state_validate () from /usr/lib64/dri/nouveau_dri.so
#3  0x00007ffff0c33670 in nvc0_draw_vbo () from /usr/lib64/dri/nouveau_dri.so
#4  0x00007ffff08ec867 in st_draw_vbo () from /usr/lib64/dri/nouveau_dri.so
#5  0x00007ffff08be81c in vbo_draw_arrays () from /usr/lib64/dri/nouveau_dri.so
#6  0x00005555555b21b7 in tutorial_02::gl::Gl::DrawArrays (self=0x7ffff6868010, mode=4, first=0, count=3) at target/debug/build/glium-e8f4c0a69cec8d2d/out/gl_bindings.rs:11032
#7  0x00005555555acee9 in tutorial_02::ops::draw::draw<glium::uniforms::uniforms::EmptyUniforms,&glium::vertex::buffer::VertexBuffer<tutorial_02::main::Vertex>> (context=0x7ffff6868010, framebuffer=..., vertex_buffers=0x7fffffffd548, indices=..., program=0x7fffffffd038, uniforms=0x5555557fc297 <const16333>, draw_parameters=0x7fffffffccb0, dimensions=...) at src/ops/draw.rs:320
#8  0x00005555555aa751 in tutorial_02::Frame.Surface::draw<&glium::vertex::buffer::VertexBuffer<tutorial_02::main::Vertex>,&glium::index::NoIndices,glium::uniforms::uniforms::EmptyUniforms> (self=0x7fffffffce48, vertex_buffer=0x7fffffffd548, index_buffer=0x7fffffffd210, program=0x7fffffffd038, uniforms=0x5555557fc297 <const16333>, draw_parameters=0x7fffffffccb0) at src/lib.rs:1083
#9  0x0000555555576f84 in tutorial_02::main () at examples/tutorial-02.rs:48
#10 0x00005555557ccf85 in sys_common::unwind::try::try_fn::h13449604025847140769 ()
#11 0x00005555557ca969 in __rust_try ()
#12 0x00005555557ccc20 in rt::lang_start::h426b3aba4736785fsbx ()
#13 0x00005555555b31da in main ()
(gdb)
Comment 21 Jim Blandy 2015-10-31 15:37:19 UTC
I have no idea what this code is supposed to be doing, but here's what I can infer:

The call to pushbuf_kref crashes because the `struct nouveau_bo *bo` argument is NULL, and cli_push_get tries to use it. The caller of pushbuf_kref, pushbuf_validate, is iterating over a list of brefs; the current bref's bo field is NULL.

This bref was created by nouveau_bufctx_refn, which was passed a NULL `bo` argument. Its caller is nvc0_add_resident, which was passed a `struct nv04_resource *` whose `bo` field is NULL.

This nv04_resource was created by a call to nouveau_buffer_create in which buffer->domain is never set to anything other than 0. Looking at nouveau_buffer_allocate, it seems like a domain of zero is a legitimate value; the last branch of the if-else chain asserts that this is the case. Since that path doesn't set buf->bo, it seems it's legitimate for buf->bo to be NULL.

pushbuf_kref seems adamant that bo should be non-NULL; both cli_push_get and cli_kref_get require it. At this point I'm lost: should nouveau_bufctx_refn never be passed a NULL bo? Should such a bufref never make it onto the list that pushbuf_validate sees? I'm not sure.

Here's the stack trace at the call to nouveau_bufctx_refn:

#0  nouveau_bufctx_refn (bctx=0x555555b3eea0, bin=bin@entry=1, bo=0x0, flags=256) at bufctx.c:126
#1  0x00007ffff0c33154 in nvc0_add_resident (flags=256, res=0x555555bf4800, bin=1, bufctx=<optimized out>) at nvc0/nvc0_winsys.h:29
#2  nvc0_validate_vertex_buffers_shared (nvc0=0x555555b3cf30) at nvc0/nvc0_vbo.c:407
#3  nvc0_vertex_arrays_validate (nvc0=0x555555b3cf30) at nvc0/nvc0_vbo.c:504
#4  0x00007ffff0c28e8e in nvc0_state_validate (nvc0=nvc0@entry=0x555555b3cf30, mask=mask@entry=4294967295, words=words@entry=8) at nvc0/nvc0_state_validate.c:651
#5  0x00007ffff0c33670 in nvc0_draw_vbo (pipe=0x555555b3cf30, info=0x7fffffffb9f0) at nvc0/nvc0_vbo.c:893
#6  0x00007ffff08ec867 in st_draw_vbo (ctx=<optimized out>, prims=0x7fffffffbab0, nr_prims=1, ib=0x0, index_bounds_valid=<optimized out>, min_index=0, max_index=2, tfb_vertcount=0x0, indirect=0x0) at state_tracker/st_draw.c:286
#7  0x00007ffff08be81c in vbo_draw_arrays (ctx=0x7ffff7f22010, mode=4, start=0, count=3, numInstances=1, baseInstance=0) at vbo/vbo_exec_array.c:645
#8  0x00005555555b21b7 in tutorial_02::gl::Gl::DrawArrays (self=0x7ffff6868010, mode=4, first=0, count=3) at target/debug/build/glium-e8f4c0a69cec8d2d/out/gl_bindings.rs:11032
#9  0x00005555555acee9 in tutorial_02::ops::draw::draw<glium::uniforms::uniforms::EmptyUniforms,&glium::vertex::buffer::VertexBuffer<tutorial_02::main::Vertex>> (context=0x7ffff6868010, framebuffer=..., vertex_buffers=0x7fffffffdc08, indices=..., program=0x7fffffffd6f8, uniforms=0x5555557fc297 <const16333>, draw_parameters=0x7fffffffd370, dimensions=...) at src/ops/draw.rs:320
#10 0x00005555555aa751 in tutorial_02::Frame.Surface::draw<&glium::vertex::buffer::VertexBuffer<tutorial_02::main::Vertex>,&glium::index::NoIndices,glium::uniforms::uniforms::EmptyUniforms> (self=0x7fffffffd508, vertex_buffer=0x7fffffffdc08, index_buffer=0x7fffffffd8d0, program=0x7fffffffd6f8, uniforms=0x5555557fc297 <const16333>, draw_parameters=0x7fffffffd370) at src/lib.rs:1083
#11 0x0000555555576f84 in tutorial_02::main () at examples/tutorial-02.rs:48
#12 0x00005555557ccf85 in sys_common::unwind::try::try_fn::h13449604025847140769 ()
#13 0x00005555557ca969 in __rust_try ()
#14 0x00005555557ccc20 in rt::lang_start::h426b3aba4736785fsbx ()
#15 0x00005555555b31da in main ()
(gdb)
Comment 22 Jim Blandy 2015-10-31 16:19:58 UTC
Steps to reproduce:

1) Install Rust from www.rust-lang.org, which provides the 'cargo' command.
2) git clone git@github.com:tomaka/glium.git
3) cd glium
4) cargo build
5) cargo build --example tutorial-02
6) ./target/debug/examples/tutorial-02
Comment 23 Ilia Mirkin 2015-10-31 17:18:01 UTC
(In reply to Jim Blandy from comment #21)
> I have no idea what this code is supposed to be doing, but here's what I can
> infer:
> 
> The call to pushbuf_kref crashes because the `struct nouveau_bo *bo`
> argument is NULL, and cli_push_get tries to use it. The caller of
> pushbuf_kref, pushbuf_validate, is iterating over a list of brefs; the
> current bref's bo field is NULL.
> 
> This bref was created by nouveau_bufctx_refn, which was passed a NULL `bo`
> argument. Its caller is nvc0_add_resident, which was passed a `struct
> nv04_resource *` whose `bo` field is NULL.
> 
> This nv04_resource was created by a call to nouveau_buffer_create in which
> buffer->domain is never set to anything other than 0. Looking at
> nouveau_buffer_allocate, it seems like a domain of zero is a legitimate
> value; the last branch of the if-else chain asserts that this is the case.
> Since that path doesn't set buf->bo, it seems it's legitimate for buf->bo to
> be NULL.
> 
> pushbuf_kref seems adamant that bo should be non-NULL; both cli_push_get and
> cli_kref_get require it. At this point I'm lost: should nouveau_bufctx_refn
> never be passed a NULL bo? Should such a bufref never make it onto the list
> that pushbuf_validate sees? I'm not sure.
> 
> Here's the stack trace at the call to nouveau_bufctx_refn:
> 
> #0  nouveau_bufctx_refn (bctx=0x555555b3eea0, bin=bin@entry=1, bo=0x0,
> flags=256) at bufctx.c:126
> #1  0x00007ffff0c33154 in nvc0_add_resident (flags=256, res=0x555555bf4800,
> bin=1, bufctx=<optimized out>) at nvc0/nvc0_winsys.h:29
> #2  nvc0_validate_vertex_buffers_shared (nvc0=0x555555b3cf30) at
> nvc0/nvc0_vbo.c:407

Whoa, great analysis! And makes a *ton* more sense than my thought, which was that the GPU hung and we ran out of GEM handles making pushbufs.

So this is one of those idiotic bo-less resources. Ugh. Will check if your repro makes it happen for me too.
Comment 24 Ilia Mirkin 2015-10-31 22:22:12 UTC
Hmmm... looks like rust isn't quite ready for prime-time -- there is no 'cargo' gentoo ebuild. (Apparently cargo can't be built hermetically?) So I can't repro.

I'm a little worried about how that buffer object came to be. It suggests we're missing some PIPE_BIND_* flags somewhere, or something is creating a buffer without any bind flags set. Can you look at the resource's "bind" property and see what it is?
Comment 25 Ilia Mirkin 2015-10-31 23:11:44 UTC
I believe this is now possible with ARB_direct_state_access. While I add support for this and add some asserts so that this doesn't happen in the future, would either of you mind retesting with

MESA_EXTENSION_OVERRIDE=-GL_ARB_direct_state_access

which should prevent those endpoints from appearing? I somewhat doubt that this is the b2g issue though, that seems to be using GLES2 which doesn't have anything like this.
Comment 26 Jim Blandy 2015-11-01 07:32:12 UTC
(In reply to Ilia Mirkin from comment #24)
> Hmmm... looks like rust isn't quite ready for prime-time -- there is no
> 'cargo' gentoo ebuild. (Apparently cargo can't be built hermetically?) So I
> can't repro.

You really should try the tarballs on rust-lang.org. It's not as nice as a package, but it's straightforward enough for a one-shot activity like this.

(In reply to Ilia Mirkin from comment #25)
> I believe this is now possible with ARB_direct_state_access. While I add
> support for this and add some asserts so that this doesn't happen in the
> future, would either of you mind retesting with
> 
> MESA_EXTENSION_OVERRIDE=-GL_ARB_direct_state_access
> 
> which should prevent those endpoints from appearing? I somewhat doubt that
> this is the b2g issue though, that seems to be using GLES2 which doesn't
> have anything like this.

Thanks for looking into this! I still get segfaults. The entry in extension_table for GL_ARB_direct_state_access is:

   { "GL_ARB_draw_buffers", o(dummy_true), GL, 2002 },

so I don't think that env var setting will do anything, just stick the name in cant_disable_extensions. I infer from the error message in get_extension_override that it's a permanently enabled extension.

(OT: I think in many ways Rust is ready for prime time, but the project has only begun to try to take into account distributions' needs. Check this out: https://internals.rust-lang.org/t/perfecting-rust-packaging/2623)
Comment 27 Ilia Mirkin 2015-11-01 07:36:05 UTC
Created attachment 119323 [details]
deal with bind == 0

Oh blast, you're right. Can't disable GL_ARB_direct_state_access, since it's o(dummy_true). Try this mesa patch, which should fix it (but might break things on nv30... need to figure that out).
Comment 28 Jim Blandy 2015-11-01 07:38:47 UTC
(In reply to Jim Blandy from comment #26)
> Thanks for looking into this! I still get segfaults. The entry in
> extension_table for GL_ARB_direct_state_access is:
> 
>    { "GL_ARB_draw_buffers", o(dummy_true), GL, 2002 },

Err, I meant, it's the line above that:

   { "GL_ARB_direct_state_access", o(dummy_true), GLC, 2014 },
Comment 29 Jim Blandy 2015-11-01 16:52:31 UTC
(In reply to Ilia Mirkin from comment #27)
> Created attachment 119323 [details]
> deal with bind == 0
> 
> Oh blast, you're right. Can't disable GL_ARB_direct_state_access, since it's
> o(dummy_true). Try this mesa patch, which should fix it (but might break
> things on nv30... need to figure that out).

Okay, cool. Building Mesa from source isn't something I can dive into right now, but I'm hoping I'll have more time for this project in the near future. (I tried just whacking the domain value into *buffer with GDB and seeing if the code could proceed, but optimized code foiled me.)
Comment 30 Ilia Mirkin 2015-11-01 21:44:17 UTC
(In reply to Jim Blandy from comment #29)
> (In reply to Ilia Mirkin from comment #27)
> > Created attachment 119323 [details]
> > deal with bind == 0
> > 
> > Oh blast, you're right. Can't disable GL_ARB_direct_state_access, since it's
> > o(dummy_true). Try this mesa patch, which should fix it (but might break
> > things on nv30... need to figure that out).
> 
> Okay, cool. Building Mesa from source isn't something I can dive into right
> now, but I'm hoping I'll have more time for this project in the near future.
> (I tried just whacking the domain value into *buffer with GDB and seeing if
> the code could proceed, but optimized code foiled me.)

You can change your application to pretend that GL_ARB_direct_state_access isn't enabled, which should prevent it from using glCreateBuffers() and the glNamedBuffer* calls.

Should be easy enough to modify src/context/extensions.rs by e.g. introducing a typo into the GL_ARB_direct_state_access string. Or doing a fixup after-the-fact.

[As an aside, in src/buffer/alloc.rs, you appear to have at least one instance that only checks for GL4.5 and not the ext as well... oops? I'd personally recommend never checking for explicit GL versions and only looking at the exts. You can also set the ext bools based on the GL versions.

    if ctxt.version >= &Version(Api::Gl, 4, 5) {
        ctxt.gl.NamedBufferSubData(self.id, offset_bytes as ...

]
Comment 31 Ilia Mirkin 2015-11-23 05:30:18 UTC
I've pushed out a couple of changes which might improve the situation. Please give your software a shot and see if it stops crashing. This should definitely resolve the glium issues... Gabriele, would ideally hear from you if they fix anything on your end.

Specifically these two commits:

http://cgit.freedesktop.org/mesa/mesa/commit/?id=079f713754a9e5d7802b655d54320bd37f24fbfa
http://cgit.freedesktop.org/mesa/mesa/commit/?id=ad5f6b03e793b9390e3b9f3eca68bd43f9d809eb
Comment 32 Gabriele Svelto 2015-11-23 09:41:25 UTC
I'll try rebuilding mesa using the mesa-9999 packages which should get me the current master and will report back ASAP.
Comment 33 Gabriele Svelto 2015-11-23 10:34:09 UTC
OK, I've just tried to reproduce the bug with the latest master build and while I haven't managed to crash the emulator yet I've found this output. This was in the kernel log:

[ 1958.357837] nouveau E[emulator-x86[5663]] multiple instances of buffer 5 on validation list
[ 1958.357841] nouveau E[emulator-x86[5663]] validate_init
[ 1958.357843] nouveau E[emulator-x86[5663]] validate: -22

This is from the emulator output itself:

nouveau: kernel rejected pushbuf: Invalid argument
nouveau: ch0: krec 0 pushes 1 bufs 12 relocs 0
nouveau: ch0: buf 00000000 00000005 00000004 00000004 00000000
nouveau: ch0: buf 00000001 00000005 00000004 00000004 00000000
nouveau: ch0: buf 00000002 00000019 00000002 00000000 00000002
nouveau: ch0: buf 00000003 00000048 00000002 00000002 00000000
nouveau: ch0: buf 00000004 00000104 00000002 00000002 00000000
nouveau: ch0: buf 00000005 00000107 00000002 00000002 00000000
nouveau: ch0: buf 00000006 0000010b 00000002 00000002 00000000
nouveau: ch0: buf 00000007 00000065 00000002 00000002 00000000
nouveau: ch0: buf 00000008 000000f8 00000002 00000002 00000000
nouveau: ch0: buf 00000009 00000108 00000002 00000002 00000000
nouveau: ch0: buf 0000000a 0000002f 00000002 00000002 00000000
nouveau: ch0: buf 0000000b 00000032 00000002 00000002 00000000
nouveau: ch0: psh 00000001 0000071e24 0000073838
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x41506f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x43800000
nouveau: 	0x43800000
nouveau: 	0x42800000
nouveau: 	0x43800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x42a00000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3e800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047458
nouveau: 	0x00051801
nouveau: 	0x00046f00
nouveau: 	0x0000607f
nouveau: 	0x40086f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00002001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x41506f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x43800000
nouveau: 	0x44000000
nouveau: 	0x42800000
nouveau: 	0x43800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x42a00000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3e800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047458
nouveau: 	0x0002e601
nouveau: 	0x00046f00
nouveau: 	0x0000607f
nouveau: 	0x40086f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00002001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x41506f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x43800000
nouveau: 	0x44400000
nouveau: 	0x42800000
nouveau: 	0x43800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x42a00000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3e800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047458
nouveau: 	0x00051c01
nouveau: 	0x00046f00
nouveau: 	0x0000607f
nouveau: 	0x40086f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00002001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x41506f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x43800000
nouveau: 	0x44800000
nouveau: 	0x42800000
nouveau: 	0x43800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x42a00000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3e800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047458
nouveau: 	0x00051e01
nouveau: 	0x00046f00
nouveau: 	0x0000607f
nouveau: 	0x40086f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00002001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x41506f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x43800000
nouveau: 	0x44a00000
nouveau: 	0x42800000
nouveau: 	0x43800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x42a00000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3e800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047458
nouveau: 	0x00052001
nouveau: 	0x00046f00
nouveau: 	0x0000607f
nouveau: 	0x40086f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00002001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
nouveau: 	0x00086e04
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086e14
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086e24
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086e34
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086e44
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086e54
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086e64
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086e74
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086e84
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086e94
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086ea4
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086eb4
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086ec4
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086ed4
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086ee4
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00086ef4
nouveau: 	0x01400000
nouveau: 	0x01e00000
nouveau: 	0x00087650
nouveau: 	0x0000000b
nouveau: 	0x00000000
nouveau: 	0x000476b8
nouveau: 	0x00000008
nouveau: 	0x000476b0
nouveau: 	0x00000009
nouveau: 	0x0004740c
nouveau: 	0x0007f9c0
nouveau: 	0x0004798c
nouveau: 	0x00000008
nouveau: 	0x00047298
nouveau: 	0x00000004
nouveau: 	0x000479a8
nouveau: 	0x00000000
nouveau: 	0x0004796c
nouveau: 	0x00000000
nouveau: 	0x00047414
nouveau: 	0x0007fec0
nouveau: 	0x0004764c
nouveau: 	0x00000000
nouveau: 	0x00047914
nouveau: 	0x00000000
nouveau: 	0x000476ac
nouveau: 	0x00000006
nouveau: 	0x000876bc
nouveau: 	0x03020100
nouveau: 	0x40400504
nouveau: 	0x00147900
nouveau: 	0x00000000
nouveau: 	0x01000404
nouveau: 	0x00000004
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046fd4
nouveau: 	0x00000000
nouveau: 	0x000475cc
nouveau: 	0x00000000
nouveau: 	0x00047988
nouveau: 	0x08020402
nouveau: 	0x00107540
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047798
nouveau: 	0x00000000
nouveau: 	0x00047510
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x41506f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x43a00000
nouveau: 	0x41f80000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047458
nouveau: 	0x00052a01
nouveau: 	0x00046f00
nouveau: 	0x0000607f
nouveau: 	0x40086f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00002001
nouveau: 	0x000477b8
nouveau: 	0x00000000
nouveau: 	0x00046da8
nouveau: 	0x00000000
nouveau: 	0x00046da4
nouveau: 	0x00000001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x41506f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x42700000
nouveau: 	0x41a00000
nouveau: 	0x43be0000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3d800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047458
nouveau: 	0x00050001
nouveau: 	0x00046f00
nouveau: 	0x0000607f
nouveau: 	0x40086f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00002001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x41506f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x43960000
nouveau: 	0x42700000
nouveau: 	0x41a00000
nouveau: 	0x43be0000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f700000
nouveau: 	0x00000000
nouveau: 	0x3d800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00002001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
nouveau: 	0x00087650
nouveau: 	0x0000000b
nouveau: 	0x00000000
nouveau: 	0x000476b8
nouveau: 	0x00000004
nouveau: 	0x000476b0
nouveau: 	0x00000007
nouveau: 	0x0004740c
nouveau: 	0x0007fe00
nouveau: 	0x0004798c
nouveau: 	0x00000004
nouveau: 	0x00047298
nouveau: 	0x00000004
nouveau: 	0x000479a8
nouveau: 	0x00000000
nouveau: 	0x0004796c
nouveau: 	0x00000000
nouveau: 	0x00047414
nouveau: 	0x0007ff80
nouveau: 	0x0004764c
nouveau: 	0x00000000
nouveau: 	0x00047914
nouveau: 	0x00000000
nouveau: 	0x000476ac
nouveau: 	0x00000004
nouveau: 	0x000476bc
nouveau: 	0x03020100
nouveau: 	0x00147900
nouveau: 	0x00000000
nouveau: 	0x01000404
nouveau: 	0x00000004
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046fd4
nouveau: 	0x00000000
nouveau: 	0x000475cc
nouveau: 	0x00000000
nouveau: 	0x00047988
nouveau: 	0x08000400
nouveau: 	0x00107540
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047798
nouveau: 	0x00000000
nouveau: 	0x00047510
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x40d06f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x43a00000
nouveau: 	0x43f00000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xc3f00000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x3e425bf8
nouveau: 	0x3e425bf8
nouveau: 	0x3e425bf8
nouveau: 	0x3f72f2f4
nouveau: 	0x00047458
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000607f
nouveau: 	0x40086f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00000000
nouveau: 	0x000477b8
nouveau: 	0x00000000
nouveau: 	0x00046da8
nouveau: 	0x00000000
nouveau: 	0x00046da4
nouveau: 	0x00000001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
nouveau: 	0x00087650
nouveau: 	0x0000000b
nouveau: 	0x00000000
nouveau: 	0x000476b8
nouveau: 	0x00000008
nouveau: 	0x000476b0
nouveau: 	0x00000009
nouveau: 	0x0004740c
nouveau: 	0x0007f9c0
nouveau: 	0x0004798c
nouveau: 	0x00000008
nouveau: 	0x00047298
nouveau: 	0x00000004
nouveau: 	0x000479a8
nouveau: 	0x00000000
nouveau: 	0x0004796c
nouveau: 	0x00000000
nouveau: 	0x00047414
nouveau: 	0x0007fec0
nouveau: 	0x0004764c
nouveau: 	0x00000000
nouveau: 	0x00047914
nouveau: 	0x00000000
nouveau: 	0x000476ac
nouveau: 	0x00000006
nouveau: 	0x000876bc
nouveau: 	0x03020100
nouveau: 	0x40400504
nouveau: 	0x00147900
nouveau: 	0x00000000
nouveau: 	0x01000404
nouveau: 	0x00000004
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046fd4
nouveau: 	0x00000000
nouveau: 	0x000475cc
nouveau: 	0x00000000
nouveau: 	0x00047988
nouveau: 	0x08020402
nouveau: 	0x00107540
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047798
nouveau: 	0x00000000
nouveau: 	0x00047510
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x41506f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x43a00000
nouveau: 	0x42980000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xc2d00000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047458
nouveau: 	0x00050201
nouveau: 	0x00046f00
nouveau: 	0x0000607f
nouveau: 	0x40086f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00002001
nouveau: 	0x000477b8
nouveau: 	0x00000000
nouveau: 	0x00046da8
nouveau: 	0x00000000
nouveau: 	0x00046da4
nouveau: 	0x00000001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007c
nouveau: 	0x41506f04
nouveau: 	0x3bcccccd
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x80000000
nouveau: 	0xbb888889
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xbf800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x43ae0000
nouveau: 	0x43800000
nouveau: 	0x43040000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0xc3f00000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x3eb80000
nouveau: 	0x3f800000
nouveau: 	0x3f040000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00046f00
nouveau: 	0x0000007d
nouveau: 	0x40106f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047458
nouveau: 	0x00000e01
nouveau: 	0x00046f00
nouveau: 	0x0000607f
nouveau: 	0x40086f04
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00047454
nouveau: 	0x00002001
nouveau: 	0x00047ac0
nouveau: 	0x7e080000
nouveau: 	0x00046900
nouveau: 	0x00000000
nouveau: 	0x000475dc
nouveau: 	0x00000004
nouveau: 	0x40607640
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x3f800000
nouveau: 	0x3f800000
nouveau: 	0x00000000
nouveau: 	0x00000000
nouveau: 	0x000475e0
nouveau: 	0x00000000
Comment 34 Gabriele Svelto 2015-11-23 14:12:39 UTC
I've been running the emulator for a while and it hasn't crashed yet but I've found yet more warning/error messages in my kernel log and they seem related to it:

[ 3053.470749] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 0 MP 0: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.470769] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 0 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.470789] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 1 MP 0: INVALID_OPCODE at 07fb80 warp 0, opcode 00000000 00000000
[ 3053.470805] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 1 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.470830] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 2 MP 0: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.470846] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 2 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.470850] nouveau E[  PGRAPH][0000:01:00.0] ch 5 [0x001f768000 emulator-x86[5663]] subc 3 class 0x8297 mthd 0x0f04 data 0x3f800000
[ 3053.470903] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 0 MP 0: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.470920] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 0 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.470942] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 1 MP 0: INVALID_OPCODE at 07fb80 warp 0, opcode 00000000 00000000
[ 3053.470958] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 1 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.470980] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 2 MP 0: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471000] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 2 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471005] nouveau E[  PGRAPH][0000:01:00.0] ch 5 [0x001f768000 emulator-x86[5663]] subc 3 class 0x8297 mthd 0x0f04 data 0x00000000
[ 3053.471060] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 0 MP 0: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471077] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 0 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471098] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 1 MP 0: INVALID_OPCODE at 07fb80 warp 0, opcode 00000000 00000000
[ 3053.471115] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 1 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471136] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 2 MP 0: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471153] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 2 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471158] nouveau E[  PGRAPH][0000:01:00.0] ch 5 [0x001f768000 emulator-x86[5663]] subc 3 class 0x8297 mthd 0x0f04 data 0x00000000
[ 3053.471213] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 0 MP 0: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471231] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 0 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471252] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 1 MP 0: INVALID_OPCODE at 07fb80 warp 0, opcode 00000000 00000000
[ 3053.471268] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 1 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471288] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 2 MP 0: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471304] nouveau E[  PGRAPH][0000:01:00.0] TRAP_MP_EXEC - TP 2 MP 1: INVALID_OPCODE at 07ff00 warp 1, opcode 00000000 00000000
[ 3053.471308] nouveau E[  PGRAPH][0000:01:00.0] ch 5 [0x001f768000 emulator-x86[5663]] subc 3 class 0x8297 mthd 0x15e0 data 0x00000000

I'm not sure if they're related to the issue at hand though.
Comment 35 Gabriele Svelto 2015-12-04 13:10:20 UTC
I've updated mesa again and running from the current master I encounter the segfault again. This time though this is the only message that pops up in the kernel log:

[ 4684.326211] emulator-x86[19034]: segfault at 4 ip 00000000f5f49403 sp 00000000ac6fc660 error 4 in libdrm_nouveau.so.2.0.0[f5f46000+7000]

I'm wondering if running a master mesa with a non-master libdrm is supported at all.
Comment 36 Emil Velikov 2015-12-04 14:41:55 UTC
(In reply to Gabriele Svelto from comment #35)
> I've updated mesa again and running from the current master I encounter the
> segfault again. This time though this is the only message that pops up in
> the kernel log:
> 
> [ 4684.326211] emulator-x86[19034]: segfault at 4 ip 00000000f5f49403 sp
> 00000000ac6fc660 error 4 in libdrm_nouveau.so.2.0.0[f5f46000+7000]
> 
> I'm wondering if running a master mesa with a non-master libdrm is supported
> at all.

If it build again given libdrm{,-nouveau} version it should work. Bugs on the other hand are something that occasionally exist.

Which version (sha) is the above libdrm-nouveau ? Can you disassemble at the given offset ?
Comment 37 Ilia Mirkin 2015-12-04 14:45:20 UTC
(In reply to Gabriele Svelto from comment #35)
> I've updated mesa again and running from the current master I encounter the
> segfault again. This time though this is the only message that pops up in
> the kernel log:
> 
> [ 4684.326211] emulator-x86[19034]: segfault at 4 ip 00000000f5f49403 sp
> 00000000ac6fc660 error 4 in libdrm_nouveau.so.2.0.0[f5f46000+7000]
> 
> I'm wondering if running a master mesa with a non-master libdrm is supported
> at all.

Most likely the emulator is doing GL stuff from different threads, which doesn't work with nouveau. Sorry :(
Comment 38 Gabriele Svelto 2015-12-04 15:24:02 UTC
Yes, the emulator seems to be calling GL commands from multiple threads, or at least the traces I got seemed to have different thread identifiers for different commands.
Comment 39 Ilia Mirkin 2015-12-04 15:29:19 UTC
(In reply to Gabriele Svelto from comment #38)
> Yes, the emulator seems to be calling GL commands from multiple threads, or
> at least the traces I got seemed to have different thread identifiers for
> different commands.

Unfortunately nouveau doesn't protect against concurrency and when multiple threads call into the GL simultaneously, will fall flat on its face.

Fixing this is on my todo list... but my todo list is long, and this is a tricky task to do so as not to pessimize the 99.99% use-case of single-threaded GL usage.
Comment 40 Tomasz Paweł Gajc 2016-12-10 14:35:31 UTC
Looks like this is related to broken multi-threading in nouveau
Comment 41 David Kredba 2017-01-02 07:37:58 UTC
I am getting the same with libdrm-2.4.74, mesa=13.0.2, crashes when the html5test web page is opened in the Konqueror browser with QTWebengine-5.7.1:
libdrm-2.4.74/nouveau/pushbuf.c:727: nouveau_pushbuf_data: Assertion „kref“failed

[New Thread 0x7fff655dc700 (LWP 21049)]
konqueror: /var/tmp/portage/x11-libs/libdrm-2.4.74/work/libdrm-2.4.74/nouveau/pushbuf.c:727: nouveau_pushbuf_data: Předpoklad „kref“ nesplněn.

Thread 1 "konqueror" received signal SIGABRT, Aborted.
0x00007ffff7767228 in raise () from /lib64/libc.so.6
(gdb) where
#0  0x00007ffff7767228 in raise () from /lib64/libc.so.6
#1  0x00007ffff77686aa in abort () from /lib64/libc.so.6
#2  0x00007ffff7760167 in ?? () from /lib64/libc.so.6
#3  0x00007ffff7760212 in __assert_fail () from /lib64/libc.so.6
#4  0x00007fffe0619e54 in nouveau_pushbuf_data (push=push@entry=0x6d0d80, bo=0x6a58b0, offset=331932, length=496)
    at /var/tmp/portage/x11-libs/libdrm-2.4.74/work/libdrm-2.4.74/nouveau/pushbuf.c:727
#5  0x00007fffe0619d9b in nouveau_pushbuf_data (push=push@entry=0x6d0d80, bo=bo@entry=0x0, offset=offset@entry=0, length=length@entry=0)
    at /var/tmp/portage/x11-libs/libdrm-2.4.74/work/libdrm-2.4.74/nouveau/pushbuf.c:719
#6  0x00007fffe0619ee9 in pushbuf_submit (push=push@entry=0x6d0d80, chan=<optimized out>, chan=<optimized out>)
    at /var/tmp/portage/x11-libs/libdrm-2.4.74/work/libdrm-2.4.74/nouveau/pushbuf.c:330
#7  0x00007fffe061a18f in pushbuf_flush (push=push@entry=0x6d0d80) at /var/tmp/portage/x11-libs/libdrm-2.4.74/work/libdrm-2.4.74/nouveau/pushbuf.c:405
#8  0x00007fffe061ad50 in nouveau_pushbuf_kick (push=0x6d0d80, chan=<optimized out>) at /var/tmp/portage/x11-libs/libdrm-2.4.74/work/libdrm-2.4.74/nouveau/pushbuf.c:779
#9  0x00007fffe0f54d06 in PUSH_KICK (push=<optimized out>) at /var/tmp/portage/media-libs/mesa-13.0.2/work/mesa-13.0.2/src/gallium/drivers/nouveau/nouveau_winsys.h:59
#10 nv50_flush (pipe=0x2733370, fence=<optimized out>, flags=<optimized out>)
    at /var/tmp/portage/media-libs/mesa-13.0.2/work/mesa-13.0.2/src/gallium/drivers/nouveau/nv50/nv50_context.c:40
#11 0x00007fffe0c2bc1b in st_finish (st=st@entry=0x276c570) at /var/tmp/portage/media-libs/mesa-13.0.2/work/mesa-13.0.2/src/mesa/state_tracker/st_cb_flush.c:98
#12 0x00007fffe0c2bc80 in st_glFinish (ctx=<optimized out>) at /var/tmp/portage/media-libs/mesa-13.0.2/work/mesa-13.0.2/src/mesa/state_tracker/st_cb_flush.c:136
#13 0x00007ffff39916a9 in QOpenGLWidgetPrivate::beginCompose (this=0x2667c50) at kernel/qopenglwidget.cpp:727
#14 0x00007ffff395f629 in QWidgetPrivate::sendComposeStatus (w=<optimized out>, end=end@entry=false) at kernel/qwidget.cpp:12227
#15 0x00007ffff395f5e7 in QWidgetPrivate::sendComposeStatus (w=<optimized out>, end=end@entry=false) at kernel/qwidget.cpp:12233
#16 0x00007ffff395f5e7 in QWidgetPrivate::sendComposeStatus (w=<optimized out>, end=end@entry=false) at kernel/qwidget.cpp:12233
#17 0x00007ffff395f5e7 in QWidgetPrivate::sendComposeStatus (w=<optimized out>, end=end@entry=false) at kernel/qwidget.cpp:12233
#18 0x00007ffff395f5e7 in QWidgetPrivate::sendComposeStatus (w=<optimized out>, end=end@entry=false) at kernel/qwidget.cpp:12233
#19 0x00007ffff395f5e7 in QWidgetPrivate::sendComposeStatus (w=<optimized out>, end=end@entry=false) at kernel/qwidget.cpp:12233
#20 0x00007ffff395f5e7 in QWidgetPrivate::sendComposeStatus (w=<optimized out>, end=end@entry=false) at kernel/qwidget.cpp:12233
#21 0x00007ffff3937709 in QWidgetBackingStore::qt_flush (widget=0x75a5d0, region=..., backingStore=<optimized out>, tlw=0x75a5d0, tlwOffset=..., 
    widgetTextures=<optimized out>, widgetBackingStore=0xb17e20) at kernel/qwidgetbackingstore.cpp:132
#22 0x00007ffff3938ed9 in QWidgetBackingStore::flush (this=this@entry=0xb17e20, widget=widget@entry=0x0) at kernel/qwidgetbackingstore.cpp:1431
#23 0x00007ffff393a442 in QWidgetBackingStore::doSync (this=this@entry=0xb17e20) at kernel/qwidgetbackingstore.cpp:1323
#24 0x00007ffff393aded in QWidgetBackingStore::sync (this=0xb17e20) at kernel/qwidgetbackingstore.cpp:1179
#25 0x00007ffff3959a9f in QWidgetPrivate::syncBackingStore (this=0x75c3f0) at kernel/qwidget.cpp:1962
#26 0x00007ffff3971c08 in QWidget::event (this=this@entry=0x75a5d0, event=event@entry=0x268a660) at kernel/qwidget.cpp:9100
#27 0x00007ffff3a6fb0b in QMainWindow::event (this=this@entry=0x75a5d0, event=event@entry=0x268a660) at widgets/qmainwindow.cpp:1543
#28 0x00007ffff592c9d7 in KMainWindow::event (this=this@entry=0x75a5d0, ev=ev@entry=0x268a660)
    at /var/tmp/portage/kde-frameworks/kxmlgui-5.29.0/work/kxmlgui-5.29.0/src/kmainwindow.cpp:867
#29 0x00007ffff5971295 in KXmlGuiWindow::event (this=this@entry=0x75a5d0, ev=ev@entry=0x268a660)
    at /var/tmp/portage/kde-frameworks/kxmlgui-5.29.0/work/kxmlgui-5.29.0/src/kxmlguiwindow.cpp:118
#30 0x00007ffff7b504e4 in KonqMainWindow::event (this=0x75a5d0, e=0x268a660) at /var/tmp/portage/kde-apps/konqueror-16.12.0/work/konqueror-16.12.0/src/konqmainwindow.cpp:5494
#31 0x00007ffff392aacc in QApplicationPrivate::notify_helper (this=<optimized out>, receiver=0x75a5d0, e=0x268a660) at kernel/qapplication.cpp:3799
#32 0x00007ffff39324c6 in QApplication::notify (this=0x7fffffffd300, receiver=0x75a5d0, e=0x268a660) at kernel/qapplication.cpp:3556
#33 0x00007ffff2ea2b7a in QCoreApplication::notifyInternal2 (receiver=0x75a5d0, event=event@entry=0x268a660) at kernel/qcoreapplication.cpp:988
#34 0x00007ffff2ea51bb in QCoreApplication::sendEvent (event=0x268a660, receiver=<optimized out>) at kernel/qcoreapplication.h:231
#35 QCoreApplicationPrivate::sendPostedEvents (receiver=receiver@entry=0x0, event_type=event_type@entry=0, data=0x61ab10) at kernel/qcoreapplication.cpp:1649
#36 0x00007ffff2ea5628 in QCoreApplication::sendPostedEvents (receiver=receiver@entry=0x0, event_type=event_type@entry=0) at kernel/qcoreapplication.cpp:1503
#37 0x00007ffff2eef6d3 in postEventSourceDispatch (s=0x667670) at kernel/qeventdispatcher_glib.cpp:276
#38 0x00007fffed0995e7 in g_main_context_dispatch () from /usr/lib64/libglib-2.0.so.0
#39 0x00007fffed099840 in ?? () from /usr/lib64/libglib-2.0.so.0
#40 0x00007fffed0998ec in g_main_context_iteration () from /usr/lib64/libglib-2.0.so.0
#41 0x00007ffff2eef74f in QEventDispatcherGlib::processEvents (this=0x670e90, flags=...) at kernel/qeventdispatcher_glib.cpp:423
#42 0x00007ffff2ea1b3a in QEventLoop::exec (this=this@entry=0x7fffffffd1b0, flags=..., flags@entry=...) at kernel/qeventloop.cpp:212
#43 0x00007ffff2ea940c in QCoreApplication::exec () at kernel/qcoreapplication.cpp:1261
#44 0x00007ffff341b39c in QGuiApplication::exec () at kernel/qguiapplication.cpp:1633
#45 0x00007ffff392aa25 in QApplication::exec () at kernel/qapplication.cpp:2975
#46 0x00007ffff7b929c0 in kdemain (argc=1, argv=<optimized out>) at /var/tmp/portage/kde-apps/konqueror-16.12.0/work/konqueror-16.12.0/src/konqmain.cpp:233
#47 0x00007ffff7754720 in __libc_start_main () from /lib64/libc.so.6
#48 0x00000000004006e9 in _start ()


bug/show.html.tmpl processed on Feb 24, 2017 at 03:43:19.
(provided by the Example extension).